-- Platform Scrolling Test (ImageData)
function love.load()
  love.keyboard.setKeyRepeat(10, 1) --https://love2d.org/wiki/love.keyboard.setKeyRepeat

  local platformImageData = love.image.newImageData("foreground.png")
	local platformImageWidth = platformImageData:getWidth()
	local platformImageHeight = platformImageData:getHeight()
  local windowWidth = love.graphics.getWidth()
  
  platform = {}
  speed = 1000
  x = 0
  xMax = platformImageWidth - windowWidth

  --generate images
  tPlatformImage = {}
  for i = 1, math.ceil(platformImageWidth/windowWidth), 1 do
    local buffer = love.image.newImageData(windowWidth, platformImageHeight)
    buffer:paste(platformImageData, 0, 0, (i - 1)*windowWidth, 0)
    tPlatformImage[i] = love.graphics.newImage(buffer)
  end;
  
  --draw function, draw three images around the screen
  function drawPlatform(pX, pY)
    local currentPosition = math.floor(-x/windowWidth) + 1
    local xModWidth = math.fmod(x, windowWidth)
    for i = -1, 1, 1 do
      if tPlatformImage[currentPosition + i] then
        love.graphics.draw(tPlatformImage[currentPosition + i], pX + xModWidth + i*windowWidth, pY)
      end
    end
  end
end

function love.draw()
  drawPlatform(0, 526)
	love.graphics.print("FPS: "..love.timer.getFPS() .. '\nMem(kB): ' .. math.floor(collectgarbage("count")), 650, 20)
end

function love.keypressed(key)
  local dt = love.timer.getDelta()
  if key == "right" then
    x = x + (speed * dt)
    if x > 0 then
      x = 0
    end
  elseif key == "left" then
    x = x - (speed * dt)
    if x < -xMax then
      x = -xMax
    end
  elseif key == "escape" then
    love.event.push("q")
  end
end
